"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.SingleCheckbox = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/checkbox/index.js"));

var _multipleChoiceList = _interopRequireDefault(require("../multiple-choice-list/multiple-choice-list"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _isRequired = _interopRequireDefault(require("../is-required"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _excluded = ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormItemProps"],
    _excluded2 = ["options"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var SingleCheckbox = function SingleCheckbox(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  })),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormItemProps = _useFieldApi.FormItemProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired,
    hideLabel: true
  }, /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    checked: input.checked
  }, input, {
    defaultValue: input.value ? input.value : undefined,
    disabled: isDisabled || isReadOnly,
    value: input.name
  }, rest), isRequired ? /*#__PURE__*/_react["default"].createElement(_isRequired["default"], null, label) : label));
};

exports.SingleCheckbox = SingleCheckbox;

var Checkbox = function Checkbox(_ref) {
  var options = _ref.options,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded2);
  return options ? /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({
    options: options
  }, props)) : /*#__PURE__*/_react["default"].createElement(SingleCheckbox, props);
};

var _default = Checkbox;
exports["default"] = _default;