import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["placeholder"],
    _excluded2 = ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormItemProps"];
import React from 'react';
import AntDatePicker from "antd/es/date-picker/index.js";
import { validationError } from '../validation-error/validation-error';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";
import FormGroup from '../form-group';

var DatePicker = function DatePicker(_ref) {
  var _ref$placeholder = _ref.placeholder,
      placeholder = _ref$placeholder === void 0 ? 'Select date' : _ref$placeholder,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useFieldApi = useFieldApi(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormItemProps = _useFieldApi.FormItemProps,
      rest = _objectWithoutProperties(_useFieldApi, _excluded2);

  var invalid = validationError(meta, validateOnMount);
  return /*#__PURE__*/React.createElement(FormGroup, {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired,
    input: input
  }, /*#__PURE__*/React.createElement(AntDatePicker, _extends({
    disabled: isDisabled || isReadOnly,
    defaultValue: input.value ? input.value : undefined,
    placeholder: placeholder,
    required: isRequired,
    error: !!invalid,
    readOnly: isReadOnly
  }, input, {
    value: input.value || null,
    id: input.name
  }, rest)));
};

export default DatePicker;