import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import Form from "antd/es/form/index.js";
import { validationError } from '../validation-error/';

var FormGroup = function FormGroup(_ref) {
  var label = _ref.label,
      children = _ref.children,
      isRequired = _ref.isRequired,
      FormItemProps = _ref.FormItemProps,
      meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      helperText = _ref.helperText,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      input = _ref.input;
  var invalid = validationError(meta, validateOnMount);
  var warning = (meta.touched || validateOnMount) && meta.warning;
  var help = invalid || warning || helperText || description;
  return /*#__PURE__*/React.createElement(Form.Item, _extends({
    validateStatus: !invalid ? warning ? 'warning' : '' : 'error',
    help: help,
    label: !hideLabel && label,
    required: isRequired,
    htmlFor: input === null || input === void 0 ? void 0 : input.name
  }, FormItemProps), children);
};

export default FormGroup;