import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["label", "value"],
    _excluded2 = ["name", "component"],
    _excluded3 = ["options", "isDisabled", "label", "isRequired", "helperText", "description", "isReadOnly", "meta", "validateOnMount", "FormItemProps", "input"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React from 'react';
import AntRadio from "antd/es/radio/index.js";
import FormGroup from '../form-group';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";

var RadioOption = function RadioOption(_ref) {
  var name = _ref.name,
      _ref$option = _ref.option,
      label = _ref$option.label,
      value = _ref$option.value,
      rest = _objectWithoutProperties(_ref$option, _excluded);

  return /*#__PURE__*/React.createElement(AntRadio, _extends({
    key: "".concat(name, "-").concat(value),
    id: "".concat(name, "-").concat(value),
    value: value
  }, rest), label);
};

var Radio = function Radio(_ref2) {
  var name = _ref2.name,
      component = _ref2.component,
      props = _objectWithoutProperties(_ref2, _excluded2);

  var _useFieldApi = useFieldApi(_objectSpread(_objectSpread({}, props), {}, {
    name: name
  })),
      _useFieldApi$options = _useFieldApi.options,
      options = _useFieldApi$options === void 0 ? [] : _useFieldApi$options,
      isDisabled = _useFieldApi.isDisabled,
      label = _useFieldApi.label,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      isReadOnly = _useFieldApi.isReadOnly,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      FormItemProps = _useFieldApi.FormItemProps,
      input = _useFieldApi.input,
      rest = _objectWithoutProperties(_useFieldApi, _excluded3);

  return /*#__PURE__*/React.createElement(FormGroup, {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired
  }, /*#__PURE__*/React.createElement(AntRadio.Group, _extends({
    name: name,
    disabled: isDisabled || isReadOnly
  }, input, rest), options.map(function (option) {
    return /*#__PURE__*/React.createElement(RadioOption, {
      key: option.value,
      name: name,
      option: option
    });
  })));
};

export default Radio;