import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormItemProps"];
import React from 'react';
import AntTimePicker from "antd/es/time-picker/index.js";
import { validationError } from '../validation-error/validation-error';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";
import FormGroup from '../form-group';

var TimePicker = function TimePicker(props) {
  var _useFieldApi = useFieldApi(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      _useFieldApi$placehol = _useFieldApi.placeholder,
      placeholder = _useFieldApi$placehol === void 0 ? 'Select date' : _useFieldApi$placehol,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormItemProps = _useFieldApi.FormItemProps,
      rest = _objectWithoutProperties(_useFieldApi, _excluded);

  var invalid = validationError(meta, validateOnMount);
  return /*#__PURE__*/React.createElement(FormGroup, {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired,
    input: input
  }, /*#__PURE__*/React.createElement(AntTimePicker, _extends({
    use12Hours: true,
    format: "h:mm a",
    disabled: isDisabled || isReadOnly,
    placeholder: placeholder,
    required: isRequired,
    error: !!invalid,
    readOnly: isReadOnly,
    defaultValue: input.value ? input.value : undefined
  }, input, {
    value: input.value || null,
    id: input.name
  }, rest)));
};

export default TimePicker;