"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _index = _interopRequireDefault(require("antd/lib/row/index.js"));

var _index2 = _interopRequireDefault(require("antd/lib/col/index.js"));

var _index3 = _interopRequireDefault(require("antd/lib/button/index.js"));

var _index4 = _interopRequireDefault(require("antd/lib/typography/index.js"));

var _index5 = _interopRequireDefault(require("antd/lib/space/index.js"));

var _icons = require("@ant-design/icons");

var _formGroup = _interopRequireDefault(require("../form-group"));

var _excluded = ["remove"],
    _excluded2 = ["remove"],
    _excluded3 = ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage", "FormFieldGridProps", "FormControlProps", "buttonLabels", "validateOnMount", "isRequired", "helperText", "FormItemProps", "ArrayItemProps", "FieldsContainerProps", "RemoveContainerProps", "RemoveButtonProps", "FieldArrayRowProps", "FieldArrayRowCol", "FieldArrayHeaderProps", "FieldArrayLabelProps", "FieldArrayButtonsProps", "UndoButtonProps", "RedoButtonProps", "AddButtonProps", "FieldArrayDescriptionProps", "NoItemsMessageProps", "ErrorMessageProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var ArrayItem = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems,
      removeLabel = _ref.removeLabel,
      ArrayItemProps = _ref.ArrayItemProps,
      FieldsContainerProps = _ref.FieldsContainerProps,
      RemoveContainerProps = _ref.RemoveContainerProps,
      RemoveButtonProps = _ref.RemoveButtonProps;

  var _useFormApi = (0, _useFormApi2["default"])(),
      renderForm = _useFormApi.renderForm;

  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(computedName, "-").concat(index)
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_index["default"], ArrayItemProps, /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({
    span: 24
  }, FieldsContainerProps), renderForm([editedFields])), /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({
    span: 24
  }, RemoveContainerProps), /*#__PURE__*/_react["default"].createElement(_index3["default"], (0, _extends2["default"])({
    type: "primary",
    danger: true
  }, RemoveButtonProps, {
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    disabled: length <= minItems
  }), removeLabel)));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  var _nextRemove = _ref3.remove,
      next = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return (0, _isEqual["default"])(prev, next);
});
var defaultButtonLabels = {
  add: 'ADD',
  remove: 'REMOVE'
};
var initialState = {
  index: 0,
  history: []
};

var reducer = function reducer(state, _ref4) {
  var type = _ref4.type,
      action = _ref4.action;

  switch (type) {
    case 'redo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index + 1
      });

    case 'action':
      return {
        index: state.index + 1,
        history: [].concat((0, _toConsumableArray2["default"])(state.history.slice(0, state.index)), [action])
      };

    case 'undo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index - 1
      });

    case 'resetHistory':
      return _objectSpread(_objectSpread({}, state), {}, {
        history: state.history.slice(0, state.index)
      });

    default:
      return state;
  }
};

exports.reducer = reducer;

var DynamicArray = function DynamicArray(_ref5) {
  var props = (0, _extends2["default"])({}, _ref5);

  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      _useFieldApi$minItems = _useFieldApi.minItems,
      minItems = _useFieldApi$minItems === void 0 ? 0 : _useFieldApi$minItems,
      _useFieldApi$maxItems = _useFieldApi.maxItems,
      maxItems = _useFieldApi$maxItems === void 0 ? Infinity : _useFieldApi$maxItems,
      _useFieldApi$noItemsM = _useFieldApi.noItemsMessage,
      noItemsMessage = _useFieldApi$noItemsM === void 0 ? 'No items added' : _useFieldApi$noItemsM,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      FormControlProps = _useFieldApi.FormControlProps,
      buttonLabels = _useFieldApi.buttonLabels,
      validateOnMount = _useFieldApi.validateOnMount,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      _useFieldApi$FormItem = _useFieldApi.FormItemProps,
      FormItemProps = _useFieldApi$FormItem === void 0 ? {} : _useFieldApi$FormItem,
      _useFieldApi$ArrayIte = _useFieldApi.ArrayItemProps,
      ArrayItemProps = _useFieldApi$ArrayIte === void 0 ? {} : _useFieldApi$ArrayIte,
      _useFieldApi$FieldsCo = _useFieldApi.FieldsContainerProps,
      FieldsContainerProps = _useFieldApi$FieldsCo === void 0 ? {} : _useFieldApi$FieldsCo,
      _useFieldApi$RemoveCo = _useFieldApi.RemoveContainerProps,
      RemoveContainerProps = _useFieldApi$RemoveCo === void 0 ? {} : _useFieldApi$RemoveCo,
      _useFieldApi$RemoveBu = _useFieldApi.RemoveButtonProps,
      RemoveButtonProps = _useFieldApi$RemoveBu === void 0 ? {} : _useFieldApi$RemoveBu,
      _useFieldApi$FieldArr = _useFieldApi.FieldArrayRowProps,
      FieldArrayRowProps = _useFieldApi$FieldArr === void 0 ? {} : _useFieldApi$FieldArr,
      _useFieldApi$FieldArr2 = _useFieldApi.FieldArrayRowCol,
      FieldArrayRowCol = _useFieldApi$FieldArr2 === void 0 ? {} : _useFieldApi$FieldArr2,
      _useFieldApi$FieldArr3 = _useFieldApi.FieldArrayHeaderProps,
      FieldArrayHeaderProps = _useFieldApi$FieldArr3 === void 0 ? {} : _useFieldApi$FieldArr3,
      _useFieldApi$FieldArr4 = _useFieldApi.FieldArrayLabelProps,
      FieldArrayLabelProps = _useFieldApi$FieldArr4 === void 0 ? {} : _useFieldApi$FieldArr4,
      _useFieldApi$FieldArr5 = _useFieldApi.FieldArrayButtonsProps,
      FieldArrayButtonsProps = _useFieldApi$FieldArr5 === void 0 ? {} : _useFieldApi$FieldArr5,
      _useFieldApi$UndoButt = _useFieldApi.UndoButtonProps,
      UndoButtonProps = _useFieldApi$UndoButt === void 0 ? {} : _useFieldApi$UndoButt,
      _useFieldApi$RedoButt = _useFieldApi.RedoButtonProps,
      RedoButtonProps = _useFieldApi$RedoButt === void 0 ? {} : _useFieldApi$RedoButt,
      _useFieldApi$AddButto = _useFieldApi.AddButtonProps,
      AddButtonProps = _useFieldApi$AddButto === void 0 ? {} : _useFieldApi$AddButto,
      _useFieldApi$FieldArr6 = _useFieldApi.FieldArrayDescriptionProps,
      FieldArrayDescriptionProps = _useFieldApi$FieldArr6 === void 0 ? {} : _useFieldApi$FieldArr6,
      _useFieldApi$NoItemsM = _useFieldApi.NoItemsMessageProps,
      NoItemsMessageProps = _useFieldApi$NoItemsM === void 0 ? {} : _useFieldApi$NoItemsM,
      _useFieldApi$ErrorMes = _useFieldApi.ErrorMessageProps,
      ErrorMessageProps = _useFieldApi$ErrorMes === void 0 ? {} : _useFieldApi$ErrorMes,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded3);

  var _useReducer = (0, _react.useReducer)(reducer, initialState),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var combinedButtonLabels = _objectSpread(_objectSpread({}, defaultButtonLabels), buttonLabels);

  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error,
      submitError = meta.submitError;
  var isError = (dirty || submitFailed) && error && typeof error === 'string';
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    meta: _objectSpread(_objectSpread({}, meta), {}, {
      error: (0, _typeof2["default"])(error) === 'object' ? error.name : error
    }),
    validateOnMount: validateOnMount,
    helperText: helperText,
    FormItemProps: FormItemProps,
    isRequired: isRequired
  }, /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref6) {
    var _ref6$fields = _ref6.fields,
        map = _ref6$fields.map,
        _ref6$fields$value = _ref6$fields.value,
        value = _ref6$fields$value === void 0 ? [] : _ref6$fields$value,
        push = _ref6$fields.push,
        remove = _ref6$fields.remove;

    var pushWrapper = function pushWrapper() {
      dispatch({
        type: 'resetHistory'
      });
      push(defaultItem);
    };

    var removeWrapper = function removeWrapper(index) {
      dispatch({
        type: 'action',
        action: {
          action: 'remove',
          value: value[index]
        }
      });
      remove(index);
    };

    var undo = function undo() {
      push(state.history[state.index - 1].value);
      dispatch({
        type: 'undo'
      });
    };

    var redo = function redo() {
      remove(value.length - 1);
      dispatch({
        type: 'redo'
      });
    };

    return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
      gutter: [0, 16]
    }, FieldArrayRowProps), /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({
      span: 24
    }, FieldArrayRowCol), /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
      justify: "space-between"
    }, FieldArrayHeaderProps), /*#__PURE__*/_react["default"].createElement(_index2["default"], null, label && /*#__PURE__*/_react["default"].createElement(_index4["default"].Title, (0, _extends2["default"])({
      level: 4
    }, FieldArrayLabelProps), label)), /*#__PURE__*/_react["default"].createElement(_index2["default"], null, /*#__PURE__*/_react["default"].createElement(_index5["default"], FieldArrayButtonsProps, /*#__PURE__*/_react["default"].createElement(_index3["default"], (0, _extends2["default"])({
      type: "default",
      icon: /*#__PURE__*/_react["default"].createElement(_icons.UndoOutlined, null)
    }, UndoButtonProps, {
      onClick: undo,
      disabled: state.index === 0
    })), /*#__PURE__*/_react["default"].createElement(_index3["default"], (0, _extends2["default"])({
      type: "default",
      icon: /*#__PURE__*/_react["default"].createElement(_icons.RedoOutlined, null)
    }, RedoButtonProps, {
      onClick: redo,
      disabled: state.index === state.history.length
    })), /*#__PURE__*/_react["default"].createElement(_index3["default"], (0, _extends2["default"])({
      type: "primary"
    }, AddButtonProps, {
      onClick: pushWrapper,
      disabled: value.length >= maxItems
    }), combinedButtonLabels.add))))), description && /*#__PURE__*/_react["default"].createElement(_index2["default"], {
      span: 24
    }, /*#__PURE__*/_react["default"].createElement(_index4["default"].Text, FieldArrayDescriptionProps, description)), /*#__PURE__*/_react["default"].createElement(_index2["default"], {
      span: 24
    }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
      gutter: [0, 16]
    }, value.length <= 0 ? typeof noItemsMessage === 'string' ? /*#__PURE__*/_react["default"].createElement(_index4["default"].Text, NoItemsMessageProps, noItemsMessage) : /*#__PURE__*/_react["default"].cloneElement(noItemsMessage, NoItemsMessageProps) : map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(_index2["default"], {
        span: 24,
        key: name
      }, /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: removeWrapper,
        length: value.length,
        minItems: minItems,
        removeLabel: combinedButtonLabels.remove,
        ArrayItemProps: ArrayItemProps,
        FieldsContainerProps: FieldsContainerProps,
        RemoveContainerProps: RemoveContainerProps,
        RemoveButtonProps: RemoveButtonProps
      }));
    }))), (isError || submitError) && /*#__PURE__*/_react["default"].createElement(_index2["default"], {
      span: 12
    }, /*#__PURE__*/_react["default"].createElement(_index4["default"].Text, (0, _extends2["default"])({
      type: "danger"
    }, ErrorMessageProps), (0, _typeof2["default"])(error) === 'object' ? error.name : error || submitError)));
  }));
};

var _default = DynamicArray;
exports["default"] = _default;