"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/form/index.js"));

var _validationError = require("../validation-error/");

var FormGroup = function FormGroup(_ref) {
  var label = _ref.label,
      children = _ref.children,
      isRequired = _ref.isRequired,
      FormItemProps = _ref.FormItemProps,
      meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      helperText = _ref.helperText,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      input = _ref.input;
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var warning = (meta.touched || validateOnMount) && meta.warning;
  var help = invalid || warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(_index["default"].Item, (0, _extends2["default"])({
    validateStatus: !invalid ? warning ? 'warning' : '' : 'error',
    help: help,
    label: !hideLabel && label,
    required: isRequired,
    htmlFor: input === null || input === void 0 ? void 0 : input.name
  }, FormItemProps), children);
};

var _default = FormGroup;
exports["default"] = _default;