"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/button/index.js"));

var _index2 = _interopRequireDefault(require("antd/lib/typography/index.js"));

var _index3 = _interopRequireDefault(require("antd/lib/form/index.js"));

var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));

var _excluded = ["children", "onSubmit", "layout"],
    _excluded2 = ["children"],
    _excluded3 = ["children"],
    _excluded4 = ["children"],
    _excluded5 = ["label", "variant", "children", "buttonType"],
    _excluded6 = ["layout", "formWrapperProps"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var Title = _index2["default"].Title,
    Paragraph = _index2["default"].Paragraph;

var Form = function Form(_ref) {
  var children = _ref.children,
      onSubmit = _ref.onSubmit,
      _ref$layout = _ref.layout,
      layout = _ref$layout === void 0 ? 'vertical' : _ref$layout,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_index3["default"], (0, _extends2["default"])({
    onFinish: onSubmit,
    layout: layout
  }, props), children);
};

var Description = function Description(_ref2) {
  var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_index2["default"], props, /*#__PURE__*/_react["default"].createElement(Paragraph, null, children));
};

var TitleComponent = function TitleComponent(_ref3) {
  var children = _ref3.children,
      props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_index2["default"], props, /*#__PURE__*/_react["default"].createElement(Title, {
    level: 3
  }, children));
};

var ButtonGroup = function ButtonGroup(_ref4) {
  var children = _ref4.children,
      props = (0, _objectWithoutProperties2["default"])(_ref4, _excluded4);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    style: {
      display: 'flex',
      justifyContent: 'flex-end'
    }
  }, props), children);
};

var ButtonComponent = function ButtonComponent(_ref5) {
  var label = _ref5.label,
      variant = _ref5.variant,
      children = _ref5.children,
      buttonType = _ref5.buttonType,
      props = (0, _objectWithoutProperties2["default"])(_ref5, _excluded5);
  return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({}, props, {
    type: "primary",
    htmlType: props.type
  }), label || children);
};

var AntFormTemplate = function AntFormTemplate(_ref6) {
  var layout = _ref6.layout,
      formWrapperProps = _ref6.formWrapperProps,
      props = (0, _objectWithoutProperties2["default"])(_ref6, _excluded6);
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    FormWrapper: Form,
    Button: ButtonComponent,
    ButtonGroup: ButtonGroup,
    Title: TitleComponent,
    Description: Description,
    formWrapperProps: _objectSpread({
      layout: layout
    }, formWrapperProps)
  }, props));
};

var _default = AntFormTemplate;
exports["default"] = _default;