"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/radio/index.js"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _excluded = ["label", "value"],
    _excluded2 = ["name", "component"],
    _excluded3 = ["options", "isDisabled", "label", "isRequired", "helperText", "description", "isReadOnly", "meta", "validateOnMount", "FormItemProps", "input"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var RadioOption = function RadioOption(_ref) {
  var name = _ref.name,
      _ref$option = _ref.option,
      label = _ref$option.label,
      value = _ref$option.value,
      rest = (0, _objectWithoutProperties2["default"])(_ref$option, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    key: "".concat(name, "-").concat(value),
    id: "".concat(name, "-").concat(value),
    value: value
  }, rest), label);
};

var Radio = function Radio(_ref2) {
  var name = _ref2.name,
      component = _ref2.component,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);

  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    name: name
  })),
      _useFieldApi$options = _useFieldApi.options,
      options = _useFieldApi$options === void 0 ? [] : _useFieldApi$options,
      isDisabled = _useFieldApi.isDisabled,
      label = _useFieldApi.label,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      isReadOnly = _useFieldApi.isReadOnly,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      FormItemProps = _useFieldApi.FormItemProps,
      input = _useFieldApi.input,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded3);

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired
  }, /*#__PURE__*/_react["default"].createElement(_index["default"].Group, (0, _extends2["default"])({
    name: name,
    disabled: isDisabled || isReadOnly
  }, input, rest), options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(RadioOption, {
      key: option.value,
      name: name,
      option: option
    });
  })));
};

var _default = Radio;
exports["default"] = _default;