"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _index = _interopRequireDefault(require("antd/lib/select/index.js"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _excluded = ["input", "isReadOnly", "isDisabled", "isClearable", "placeholder", "isRequired", "label", "helperText", "validateOnMount", "meta", "options", "isSearchable", "description", "FormItemProps", "isMulti"];

var selectValue = function selectValue(option) {
  return option.sort(function (a, b) {
    return a.label.localeCompare(b.label, 'en', {
      sensitivity: 'base'
    });
  }).map(function (item) {
    return item.value;
  });
};

var Option = _index["default"].Option;

var Select = function Select(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      isClearable = _useFieldApi.isClearable,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      options = _useFieldApi.options,
      isSearchable = _useFieldApi.isSearchable,
      description = _useFieldApi.description,
      FormItemProps = _useFieldApi.FormItemProps,
      isMulti = _useFieldApi.isMulti,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired,
    input: input
  }, /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({}, input, {
    value: input.value ? input.value : undefined,
    defaultValue: input.value ? input.value : undefined,
    placeholder: placeholder || 'Please choose',
    mode: isMulti ? 'multiple' : '',
    showSearch: !!isSearchable || isMulti,
    filterOption: function filterOption(input, option) {
      return option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
    },
    required: isRequired,
    allowClear: isClearable,
    notFoundContent: "No option found",
    disabled: isDisabled || isReadOnly,
    onChange: function onChange(value, option) {
      return input.onChange(isMulti ? selectValue(option) : option ? option.value : undefined);
    },
    input: input,
    id: input.name
  }, rest), options.filter(function (option) {
    return Object.prototype.hasOwnProperty.call(option, 'value') && option.value !== null;
  }).map(function (_ref) {
    var value = _ref.value,
        label = _ref.label;
    return /*#__PURE__*/_react["default"].createElement(Option, {
      key: value,
      value: value,
      label: label
    }, label);
  })));
};

var _default = Select;
exports["default"] = _default;