"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("antd/lib/slider/index.js"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _excluded = ["value", "onChange"],
    _excluded2 = ["input", "meta", "label", "validateOnMount", "helperText", "description", "FormItemProps", "isRequired", "range", "min", "max", "isDisabled", "isReadOnly"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Slider = function Slider(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      _useFieldApi$input = _useFieldApi.input,
      value = _useFieldApi$input.value,
      onChange = _useFieldApi$input.onChange,
      input = (0, _objectWithoutProperties2["default"])(_useFieldApi$input, _excluded),
      meta = _useFieldApi.meta,
      label = _useFieldApi.label,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      FormItemProps = _useFieldApi.FormItemProps,
      isRequired = _useFieldApi.isRequired,
      range = _useFieldApi.range,
      _useFieldApi$min = _useFieldApi.min,
      min = _useFieldApi$min === void 0 ? 0 : _useFieldApi$min,
      _useFieldApi$max = _useFieldApi.max,
      max = _useFieldApi$max === void 0 ? 100 : _useFieldApi$max,
      isDisabled = _useFieldApi.isDisabled,
      isReadOnly = _useFieldApi.isReadOnly,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded2);

  (0, _react.useEffect)(function () {
    if (range === true && (!value || !Array.isArray(value))) {
      onChange([min, max]);
    }
  }, [min, max, range, value, onChange]);
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired
  }, /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    disabled: isDisabled || isReadOnly,
    onChange: onChange
  }, input, {
    value: range === true && !Array.isArray(value) ? [min, max] : value,
    range: range,
    min: min,
    max: max,
    id: input.name
  }, rest)));
};

var _default = Slider;
exports["default"] = _default;