"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/time-picker/index.js"));

var _validationError = require("../validation-error/validation-error");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formGroup = _interopRequireDefault(require("../form-group"));

var _excluded = ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormItemProps"];

var TimePicker = function TimePicker(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      _useFieldApi$placehol = _useFieldApi.placeholder,
      placeholder = _useFieldApi$placehol === void 0 ? 'Select date' : _useFieldApi$placehol,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      FormItemProps = _useFieldApi.FormItemProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    label: label,
    meta: meta,
    validateOnMount: validateOnMount,
    helperText: helperText,
    description: description,
    FormItemProps: FormItemProps,
    isRequired: isRequired,
    input: input
  }, /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    use12Hours: true,
    format: "h:mm a",
    disabled: isDisabled || isReadOnly,
    placeholder: placeholder,
    required: isRequired,
    error: !!invalid,
    readOnly: isReadOnly,
    defaultValue: input.value ? input.value : undefined
  }, input, {
    value: input.value || null,
    id: input.name
  }, rest)));
};

var _default = TimePicker;
exports["default"] = _default;