"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _index = _interopRequireDefault(require("antd/lib/button/index.js"));

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      handleNext = _ref.handleNext,
      handleSubmit = _ref.handleSubmit,
      buttonLabels = _ref.buttonLabels,
      getState = _ref.getState,
      valid = _ref.valid,
      NextButtonProps = _ref.NextButtonProps,
      SubmitButtonProps = _ref.SubmitButtonProps,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;
  var nextResult = nextStep ? (0, _selectNext["default"])(nextStep, getState) : nextStep;
  var progressNext = nextResult !== conditionalSubmitFlag && nextStep;
  return /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    type: "primary",
    htmlType: "button",
    onClick: function onClick() {
      return progressNext ? handleNext(nextResult) : handleSubmit();
    },
    disabled: !valid
  }, progressNext ? NextButtonProps : SubmitButtonProps), progressNext ? buttonLabels.next : buttonLabels.submit);
};

var WizardStepButtons = function WizardStepButtons(_ref2) {
  var disableBack = _ref2.disableBack,
      handlePrev = _ref2.handlePrev,
      nextStep = _ref2.nextStep,
      formOptions = _ref2.formOptions,
      handleNext = _ref2.handleNext,
      buttonLabels = _ref2.buttonLabels,
      ButtonProps = _ref2.ButtonProps,
      NextButtonProps = _ref2.NextButtonProps,
      CancelButtonProps = _ref2.CancelButtonProps,
      BackButtonProps = _ref2.BackButtonProps,
      SubmitButtonProps = _ref2.SubmitButtonProps,
      conditionalSubmitFlag = _ref2.conditionalSubmitFlag;
  return /*#__PURE__*/_react["default"].createElement("div", ButtonProps, formOptions.onCancel && /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    type: "button",
    variant: "contained",
    color: "secondary",
    onClick: formOptions.onCancel
  }, CancelButtonProps), buttonLabels.cancel), /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    htmlType: "button",
    disabled: disableBack,
    onClick: handlePrev
  }, BackButtonProps), buttonLabels.back), /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
    handleNext: handleNext,
    nextStep: nextStep,
    buttonLabels: buttonLabels,
    NextButtonProps: NextButtonProps,
    SubmitButtonProps: SubmitButtonProps,
    conditionalSubmitFlag: conditionalSubmitFlag
  })));
};

var _default = WizardStepButtons;
exports["default"] = _default;