"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _wizardStep = _interopRequireDefault(require("./wizard-step"));

var _index = _interopRequireDefault(require("antd/lib/steps/index.js"));

var _index2 = _interopRequireDefault(require("antd/lib/modal/index.js"));

var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard/wizard"));

var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));

var _excluded = ["buttonLabels"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var defaultButtonLabels = {
  cancel: 'Cancel',
  back: 'Back',
  next: 'Next',
  submit: 'Submit'
};
var Step = _index["default"].Step;

var WizardInternal = function WizardInternal(_ref) {
  var title = _ref.title,
      buttonLabels = _ref.buttonLabels,
      stepsInfo = _ref.stepsInfo,
      WizardProps = _ref.WizardProps,
      TitleProps = _ref.TitleProps,
      StepProps = _ref.StepProps,
      WizardStepProps = _ref.WizardStepProps,
      ButtonProps = _ref.ButtonProps,
      NextButtonProps = _ref.NextButtonProps,
      BackButtonProps = _ref.BackButtonProps,
      CancelButtonProps = _ref.CancelButtonProps,
      SubmitButtonProps = _ref.SubmitButtonProps,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;

  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
      onKeyDown = _useContext.onKeyDown,
      formOptions = _useContext.formOptions,
      handleNext = _useContext.handleNext,
      handlePrev = _useContext.handlePrev,
      prevSteps = _useContext.prevSteps,
      currentStep = _useContext.currentStep,
      jumpToStep = _useContext.jumpToStep,
      activeStepIndex = _useContext.activeStepIndex;

  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    onKeyDown: onKeyDown
  }, WizardProps), title && /*#__PURE__*/_react["default"].createElement(_index2["default"], (0, _extends2["default"])({
    title: title,
    onCancel: formOptions.onCancel
  }, TitleProps)), stepsInfo && /*#__PURE__*/_react["default"].createElement(_index["default"], (0, _extends2["default"])({
    onChange: jumpToStep,
    current: activeStepIndex
  }, StepProps), stepsInfo.map(function (step, stepIndex) {
    return /*#__PURE__*/_react["default"].createElement(Step, (0, _extends2["default"])({
      disabled: activeStepIndex < stepIndex,
      step: stepIndex,
      key: stepIndex
    }, step));
  })), /*#__PURE__*/_react["default"].createElement(_wizardStep["default"], (0, _extends2["default"])({
    handleNext: handleNext,
    handlePrev: handlePrev,
    disableBack: prevSteps.length === 0,
    buttonLabels: buttonLabels
  }, currentStep, {
    formOptions: formOptions,
    WizardStepProps: WizardStepProps,
    ButtonProps: ButtonProps,
    NextButtonProps: NextButtonProps,
    BackButtonProps: BackButtonProps,
    CancelButtonProps: CancelButtonProps,
    SubmitButtonProps: SubmitButtonProps,
    conditionalSubmitFlag: conditionalSubmitFlag
  })));
};

var WizardFinal = function WizardFinal(_ref2) {
  var buttonLabels = _ref2.buttonLabels,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal,
    buttonLabels: _objectSpread(_objectSpread({}, defaultButtonLabels), buttonLabels)
  }, props));
};

var _default = WizardFinal;
exports["default"] = _default;